image: itential/argo

variables:
  DOCKER_DRIVER: overlay2

services:
  - docker:dind

after_script:
  - rm -rf ~/.ssh

stages:
  # Lint code, test code quality, and ensure there are no insecure dependencies
  - quality
  # Run unit and integration test suites
  - test
    # publish module to npm, deploy docker registry image
  - deploy
    # Generate artifact.json file (needed for admin-essentials starting IAP 2020.1)
  - generate

generate_artifact_json:
  allow_failure: false
  except: 
    - merge_requests
  stage: generate
  script:
    - chmod +x scripts/commit.sh
    - ./scripts/commit.sh
    
codequality:
  allow_failure: true
  stage: quality
  script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run
        --env SOURCE_CODE="$PWD"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock
        "registry.gitlab.com/gitlab-org/security-products/codequality:$SP_VERSION" /code
  artifacts:
    paths: [gl-code-quality-report.json]

security:
  allow_failure: true
  stage: quality
  script:
    - node_setup
    - npm audit --registry=https://registry.npmjs.org

schema_validation:
  allow_failure: true
  stage: test
  script:
    - npm i
    - node_setup
    - npm run validateSchema

schemaLinks_validation:
  allow_failure: true
  stage: test
  script:
    - npm i
    - node_setup
    - npm run validateSchemaLinks

publish:
  stage: deploy
  only:
    - master
    - /(release\/)/
  script:
    - npm i
    - node_setup
    - deploy
# Only use spaces to indent your .yml configuration.
# -----